' Example 2 - Lock-by-Select Demo

Option Explicit

Global Const glb_Database_Name = "CITIES.MDB"
Global Const glb_Table_Name = "Tab_Cities"
Global Const glb_First_Record_ID = 1
Global Const glb_Last_Record_ID = 15

Sub Show_Status ()

    Select Case glb_Last_Status
        Case st_No_Error
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "alles o.k."
        Case st_DOS_Error
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "DOS-Fehler"
        Case st_No_File_Name
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Name der Record-Locking-Verwaltungsdatei fehlt"
        Case st_No_User_Name
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Username fehlt"
        Case st_Max_Users
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "max. Anzahl User erreicht"
        Case st_File_Destroyed
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Record-Locking-Verwaltungsdatei ist zerstrt"
        Case st_User_Not_Found
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "User nicht gefunden"
        Case st_No_Table_Name
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Name der Datenbank-Tabelle bzw. Abfrage fehlt"
        Case st_Max_Tables
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "max. Anzahl Tabellen erreicht"
        Case st_Lock_By_Same
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datensatz vom akt. Benutzer gesperrt; keine automatische Entsperrberwachung oder Zeitmarke noch nicht berschritten"
        Case st_Lock_By_Others
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datensatz von einem anderem User gesperrt; keine automatische Entsperrberwachung oder Zeitmarke noch nicht berschritten"
        Case st_Lock_By_Same_Out
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datensatz vom akt. Benutzer gesperrt; Zeitmarke fr die Sperrung berschritten, Entsperrung wird empfohlen"
        Case st_Lock_By_Others_Out
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datensatz von einem anderem User gesperrt; Zeitmarke fr die Sperrung berschritten, Entsperrung wird empfohlen"
        Case st_Max_Records
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "max. Anzahl sperrbarer Datenstze erreicht"
        Case st_Table_Not_Found
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datenbank-Tabelle bzw. Abfrage nicht gefunden"
        Case st_Record_Not_Found
            MsgBox "STATUS:" & Chr$(13) & Chr$(13) & "Datensatz nicht gefunden"
    End Select

End Sub

